#define _BSD_SOURCE
#define _DEFAULT_SOURCE
#define _POSIX_C_SOURCE 199309L
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <stdarg.h>
#include <time.h>
#include <sched.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>

#include <pcilib.h>
#include "pcilib/kmem.h"

#define DEVICE "/dev/fpga0"

#define WR(addr, value) { *(uint32_t*)(bar + addr) = value; }
#define RD(addr, value) { value = *(uint32_t*)(bar + addr); }

int main(int argc, char *argv[]) {
    uint32_t i, j;
    pcilib_t *pci;
    pcilib_kmem_handle_t *kbuf;

    void* volatile bar;
    
    pci = pcilib_open(DEVICE, PCILIB_MODEL_DETECT);
    if (!pci) {
	printf("pcilib_open\n");
	exit(1);
    }

    kbuf = pcilib_alloc_kernel_memory(pci, PCILIB_KMEM_TYPE_PAGE, 1, 4096, 4096, 0, 0);
    volatile uint32_t *ua = pcilib_kmem_get_ua(pci, kbuf);
    uintptr_t pa = pcilib_kmem_get_pa(pci, kbuf);

    printf("User: %p\n", ua);
    printf("HW  : 0x%lx\n", pa);

    int fd = open("/sys/class/test/test0/test_request",  O_RDWR);
    if (fd >= 0) {
	size_t bytes;
	char res[64];

	sprintf(res, "%p", ua);
	write(fd, res, strlen(res));
	lseek(fd, SEEK_SET, 0);
	bytes = read(fd, res, sizeof(res) - 1); 

	printf("Res : ");
	if (bytes < 0) {
	    puts("Error");
	} else {
	    res[bytes] = 0;
	    puts(res);
	}

	close(fd);
    }

    pcilib_free_kernel_memory(pci, kbuf, 0);
    
    pcilib_close(pci);
}
